#include "VirtualJoint.h"

using namespace std;
using namespace tohoku;
using namespace OpenHRP;


VirtualJoint::VirtualJoint()
{
  virtualAngle = 0.0;

  realLinks.clear();

  realJoints.clear();
  ratios.clear();
}


VirtualJoint::VirtualJoint(string in_name)
{
  name = in_name;

  virtualAngle = 0.0;

  realLinks.clear();

  realJoints.clear();
  ratios.clear();
}


VirtualJoint::~VirtualJoint()
{
  name = "";

  virtualAngle = 0.0;

  realLinks.clear();
 
  realJoints.clear();
  ratios.clear();
}


void VirtualJoint::addMember(Link* link, double ratio)
{
  realLinks.push_back(link);


  if(link->jointType == Link::ROTATIONAL_JOINT || link->jointType == Link::SLIDE_JOINT) {
    realJoints.push_back(link);
    ratios.push_back(ratio);
  }
}


double VirtualJoint::q(const double in_q)
{
  virtualAngle = in_q;
  for(unsigned int i = 0; i < realJoints.size(); i++) {
    realJoints[i]->q = in_q * ratios[i];
  }
  return in_q;
}

